'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

//import Pie from './charts/Pie.js';
//import Tree from './charts/Tree.js';
//import Radar from './charts/Radar.js';
//import Bar from './charts/Bar.js';
//import SmoothLine from './charts/SmoothLine.js';
//import StockLine from './charts/StockLine.js';
//import Scatterplot from './charts/Scatterplot.js';

//export default {
//    Pie:Pie,
//    Tree:Tree,
//    SmoothLine:SmoothLine,
//    StockLine:StockLine,
//    Radar:Radar,
//    Bar:Bar,
//    Scatterplot:Scatterplot
//};

var _chartsSmoothLineVivusJs = require('./charts/SmoothLineVivus.js');

var _chartsSmoothLineVivusJs2 = _interopRequireDefault(_chartsSmoothLineVivusJs);

var _chartsStockLineVivusJs = require('./charts/StockLineVivus.js');

var _chartsStockLineVivusJs2 = _interopRequireDefault(_chartsStockLineVivusJs);

var _chartsBarVivusJs = require('./charts/BarVivus.js');

var _chartsBarVivusJs2 = _interopRequireDefault(_chartsBarVivusJs);

var _chartsPieVivusJs = require('./charts/PieVivus.js');

var _chartsPieVivusJs2 = _interopRequireDefault(_chartsPieVivusJs);

var _chartsRadarVivusJs = require('./charts/RadarVivus.js');

var _chartsRadarVivusJs2 = _interopRequireDefault(_chartsRadarVivusJs);

var _chartsTreeVivusJs = require('./charts/TreeVivus.js');

var _chartsTreeVivusJs2 = _interopRequireDefault(_chartsTreeVivusJs);

var _chartsScatterplotVivusJs = require('./charts/ScatterplotVivus.js');

var _chartsScatterplotVivusJs2 = _interopRequireDefault(_chartsScatterplotVivusJs);

// form: true
// make objects not extensible,
// fields not removable
// and inputs always visible
var settings = {
    form: true,
    fields: {
        data: { type: 'bindingEditor' },
        options: {
            color: { type: 'colorPicker' },
            fill: { type: 'colorPicker' },
            stroke: { type: 'colorPicker' },
            legendPosition: { type: 'select', settings: { options: ['topLeft', 'topRight', 'bottomLeft', 'bottomRight'] } },
            label: { type: 'fontEditor' },
            animate: {
                fields: { type: { type: 'select', settings: { options: ['delayed', 'async', 'oneByOne'] } } }
            },

            axisY: {
                fields: {
                    orient: { type: 'select', settings: { options: ['left', 'right'] } },
                    tickValues: { type: 'tickValues' },
                    label: { type: 'fontEditor' }
                }
            },
            axisX: {
                fields: {
                    orient: { type: 'select', settings: { options: ['top', 'bottom'] } },
                    tickValues: { type: 'tickValues' },
                    label: { type: 'fontEditor' }
                }
            }
        }
    }
};

exports['default'] = {
    Pie: _underscore2['default'].extend(_chartsPieVivusJs2['default'], {
        metaData: {
            props: {
                data: {},
                accessorKey: '',
                options: {
                    margin: { top: 20, left: 20, right: 20, bottom: 20 },
                    width: 600,
                    height: 600,
                    color: '#2980B9',
                    r: 100,
                    R: 200,
                    legendPosition: 'topLeft',
                    animate: {
                        type: 'oneByOne',
                        duration: 200,
                        fillTransition: 3
                    },
                    label: {
                        fontFamily: 'Arial',
                        fontSize: 14,
                        bold: true,
                        fill: '#ECF0F1'
                    }
                }
            },
            settings: settings
        }
    }),
    Tree: _underscore2['default'].extend(_chartsTreeVivusJs2['default'], {
        metaData: {
            props: {
                data: {},
                options: {
                    margin: { top: 20, left: 50, right: 80, bottom: 20 },
                    width: 600,
                    height: 600,
                    fill: '#2980B9',
                    stroke: '#3E90F0',
                    r: 5,
                    animate: {
                        type: 'oneByOne',
                        duration: 200,
                        fillTransition: 3
                    },
                    label: {
                        fontFamily: 'Arial',
                        fontSize: 14,
                        bold: true,
                        fill: '#34495E'
                    }
                }
            },
            settings: settings
        }
    }),
    SmoothLine: _underscore2['default'].extend(_chartsSmoothLineVivusJs2['default'], {
        metaData: {
            props: {
                data: {},
                xKey: '',
                yKey: '',
                options: {
                    width: 600,
                    height: 600,
                    color: '#2980B9',
                    margin: { top: 40, left: 60, bottom: 50, right: 20 },
                    animate: {
                        type: 'delayed',
                        duration: 200
                    },
                    axisX: {
                        showAxis: true,
                        showLines: true,
                        showLabels: true,
                        showTicks: true,
                        zeroAxis: false,
                        orient: 'bottom',
                        label: {
                            fontFamily: 'Arial',
                            fontSize: 14,
                            bold: true,
                            color: '#34495E'
                        }
                    },
                    axisY: {
                        showAxis: true,
                        showLines: true,
                        showLabels: true,
                        showTicks: true,
                        zeroAxis: false,
                        orient: 'left',
                        label: {
                            fontFamily: 'Arial',
                            fontSize: 14,
                            bold: true,
                            color: '#34495E'
                        }
                    }
                }
            },
            settings: settings
        }
    }),
    StockLine: _underscore2['default'].extend(_chartsStockLineVivusJs2['default'], {
        metaData: {
            props: {
                data: {},
                xKey: '',
                yKey: '',
                options: {
                    width: 600,
                    height: 600,
                    color: '#2980B9',
                    margin: { top: 40, left: 60, bottom: 50, right: 20 },
                    animate: {
                        type: 'delayed',
                        duration: 200
                    },
                    axisX: {
                        showAxis: true,
                        showLines: true,
                        showLabels: true,
                        showTicks: true,
                        zeroAxis: false,
                        orient: 'bottom',
                        tickValues: [],
                        label: {
                            fontFamily: 'Arial',
                            fontSize: 14,
                            bold: true,
                            color: '#34495E'
                        }
                    },
                    axisY: {
                        showAxis: true,
                        showLines: true,
                        showLabels: true,
                        showTicks: true,
                        zeroAxis: false,
                        orient: 'left',
                        tickValues: [],
                        label: {
                            fontFamily: 'Arial',
                            fontSize: 14,
                            bold: true,
                            color: '#34495E'
                        }
                    }
                }
            },
            settings: settings
        }
    }),
    Radar: _underscore2['default'].extend(_chartsRadarVivusJs2['default'], {
        metaData: {
            props: {
                data: {},
                options: {
                    width: 600,
                    height: 600,
                    margin: { top: 20, left: 20, right: 20, bottom: 20 },
                    r: 300,
                    max: 150,
                    fill: '#2980B9',
                    stroke: '#2980B9',
                    animate: {
                        type: 'oneByOne',
                        duration: 200
                    },
                    label: {
                        fontFamily: 'Arial',
                        fontSize: 14,
                        bold: true,
                        color: '#34495E'
                    }
                }
            },
            settings: settings
        }
    }),
    Bar: _underscore2['default'].extend(_chartsBarVivusJs2['default'], {
        metaData: {
            props: {
                data: {},
                accessorKey: '',
                options: {
                    width: 600,
                    height: 600,
                    margin: { top: 20, left: 20, bottom: 50, right: 20 },
                    color: '#2980B9',
                    gutter: 20,
                    animate: {
                        type: 'oneByOne',
                        duration: 200,
                        fillTransition: 3
                    },
                    axisX: {
                        showAxis: true,
                        showLines: true,
                        showLabels: true,
                        showTicks: true,
                        zeroAxis: false,
                        orient: 'bottom',
                        label: {
                            fontFamily: 'Arial',
                            fontSize: 14,
                            bold: true,
                            color: '#34495E'
                        }
                    },
                    axisY: {
                        showAxis: true,
                        showLines: true,
                        showLabels: true,
                        showTicks: true,
                        zeroAxis: false,
                        orient: 'left',
                        label: {
                            fontFamily: 'Arial',
                            fontSize: 14,
                            bold: true,
                            color: '#34495E'
                        }
                    }
                }
            },
            settings: settings
        }
    }),
    Scatterplot: _underscore2['default'].extend(_chartsScatterplotVivusJs2['default'], {
        metaData: {
            props: {
                data: {},
                xKey: '',
                yKey: '',
                options: {
                    width: 600,
                    height: 600,
                    margin: { top: 40, left: 60, bottom: 30, right: 30 },
                    fill: '#2980B9',
                    stroke: '#3E90F0',
                    animate: {
                        type: 'delayed',
                        duration: 200
                    },
                    label: {
                        fontFamily: 'Arial',
                        fontSize: 14,
                        bold: true,
                        color: '#34495E'
                    },
                    axisX: {
                        showAxis: true,
                        showLines: true,
                        showLabels: true,
                        showTicks: true,
                        zeroAxis: false,
                        orient: 'bottom',
                        label: {
                            fontFamily: 'Arial',
                            fontSize: 14,
                            bold: true,
                            color: '#34495E'
                        }
                    },
                    axisY: {
                        showAxis: true,
                        showLines: true,
                        showLabels: true,
                        showTicks: true,
                        zeroAxis: false,
                        orient: 'left',
                        label: {
                            fontFamily: 'Arial',
                            fontSize: 14,
                            bold: true,
                            color: '#34495E'
                        }
                    }
                }
            },
            settings: settings
        }
    })
};
module.exports = exports['default'];